/*
 Functions.H -	Functions File (Various & Assorted)

void Error(char *Message)
int CleanUp(int Kill, int Delete)
int PreCheckFile(char *FileToCheck)
int SetTempVariables(void)
int ProcessInput(char *xInput)
void ClearBuffer(void)
DWORD WINAPI StatusDialog_Thread(LPVOID data)
DWORD WINAPI EncryptProcess_Thread(LPVOID data)
DWORD WINAPI DecryptProcess_Thread(LPVOID data)
DWORD WINAPI PackProcess_Thread(LPVOID data)
DWORD WINAPI UnpackProcess_Thread(LPVOID data)
DWORD WINAPI CompressEncryptProcess_Thread(LPVOID data)
DWORD WINAPI DecompressDecryptProcess_Thread(LPVOID data)
DWORD WINAPI CompressPackProcess_Thread(LPVOID data)
DWORD WINAPI DecompressUnpackProcess_Thread(LPVOID data)
void Update_LastUsed(void)
void FreeMemory(void)
void Clear_ReadTemp(void)
int CheckRegistered(void)
BOOL SetPriority(void)

*/

//--------------------------------------------------------------------

//////////////////////////////////////////////////////////////////////

void Error(char *Message)
{
	KillFlag = 1;
	MessageBox(GetActiveWindow(), Message ,TitleCaption,0 + MB_ICONHAND + MB_SYSTEMMODAL + MB_TASKMODAL);
	CleanUp(1,1);
}

//////////////////////////////////////////////////////////////////////

int CleanUp(int Kill, int Delete)
{
	if(Delete)
	{
		_fcloseall(); //Attempt To Close All Open Files... (If Any)
		unlink(CompressTemp);
		unlink(PackTemp);
	}

	if(Kill)
	{
		_fcloseall(); //Attempt To Close All Open Files... (If Any)
		sleep(500); // Hopfully Give Time For Files To Flush.
		unlink(CompressTemp);
		unlink(PackTemp);
		exit(0);
	}

	return 0;
}

//////////////////////////////////////////////////////////////////////

int PreCheckFile(char *FileToCheck)
{
	FILE * FileToCheck_File;
	char xDrive[255], xDir[255], xFile[255], xExt[255];
	_splitpath(FileToCheck,xDrive,xDir,xFile,xExt);

	/* Check For File Access */
	if(!FileAccess(FileToCheck,FExist)) // Check Exist
		Error("PreCheckFile: File Does Not Exist. Error 14.");

	if(IsDirectory(GlobalFileName)) // If Input Is A Directory
		return 1;

	if((FileToCheck_File = fopen(FileToCheck,"rb")) == NULL) // Check Read Access
		Error("PreCheckFile: File Does Not Allow Read Access. Error 15.");
	if(FileToCheck_File)fclose(FileToCheck_File);


	DWORD FileSize_Temp = Get_FileSize(FileToCheck);
	if(FileSize_Temp == -1)return 0;

	if(FileSize_Temp > MaxFileSize)
	{
		char MessageTemp[257];
		sprintf(MessageTemp,"128Gamma %s Requires That Files Be Under %d MB",ShortVersion,MaxFileSize/1024/1024);
		MessageBox(GetActiveWindow(),MessageTemp,TitleCaption,+ MB_SYSTEMMODAL);
		return 0;
	}

	if(FileSize_Temp < 1)
	{
		char MessageTemp[257];
		sprintf(MessageTemp,"128Gamma %s Requires That Files Contain Atleast Some Data.",ShortVersion);
		MessageBox(GetActiveWindow(),MessageTemp,TitleCaption,+ MB_SYSTEMMODAL);
		return 0;
	}

	/* Open Source File */
	if((FileToCheck_File = fopen(FileToCheck,"rb")) == NULL)
		Error("PreCheckFile: Could Not Open Source For Read. Error: 16.");

	/* Read File Flag ( If Any ) */
	fread(Buffer,sizeof(char),FlagLEN,FileToCheck_File);

	if(strcmp(Buffer,ENCFlag) == 0) // If File Encryted
	{
		if(FileToCheck_File)
			fclose(FileToCheck_File);
		return 2;
	}

	if(strcmp(Buffer,PACFlag) == 0) // If File Packed
	{
		if(FileToCheck_File)
			fclose(FileToCheck_File);
		return 3;
	}

	if(strcmp(Buffer,ENCCompress) == 0) // If File Compressed Encryted
	{
		if(FileToCheck_File)
			fclose(FileToCheck_File);
		return 4;
	}

	if(strcmp(Buffer,PACCompress) == 0) // If File Compressed Packed
	{
		if(FileToCheck_File)
			fclose(FileToCheck_File);
		return 5;
	}

	if(strcmp(Buffer,ABIFlag) == 0) // If Encryted By ABI-Coder
	{
		if(FileToCheck_File)
			fclose(FileToCheck_File);
		return 6;
	}

	if(FileToCheck_File)
		fclose(FileToCheck_File);
	return 7; // If File Not Encrypted
}

//////////////////////////////////////////////////////////////////////

int SetTempVariables(void)
{
	sprintf(PackTemp,"%s\\%s",Get_TempDirectory(),"Pack.128G");
	sprintf(CompressTemp,"%s\\%s",Get_TempDirectory(),"Compress.128G");

	if(!CompressTemp)
		return 1;
	if(!PackTemp)
		return 1;

	return 0;
}

/////////////////////////////////////////////////////////////////////

int ProcessInput(char *xInput)
{
	short ENCMethod = 0;

	if(strlen(xInput) > 0) // If Any Program Input Params
	{
		sprintf(GlobalFileName,"%s",xInput);

		/*
		0 = Cancel , Dir = 1 , Encrypted = 2 , Packed = 3
		Compressed Encrypted = 4 , Compressed Packed = 5
		ABI-Coder File = 6, Not Encrypted = 7
		*/

		ENCMethod = PreCheckFile(GlobalFileName);

		if(ENCMethod == 0) // Cancel
			return 0;

		if(ENCMethod == 1) // Directory
		{
			Pack = TRUE; // Encrypt File Flag

			DialogBox(hInstance,MAKEINTRESOURCE(100),0,PasswordDialog);
			CleanUp(0,1);
			return(0);
		}

		if(ENCMethod == 2) // Encrypted
		{
			Decrypt = TRUE; // Decrypt File Flag

			DialogBox(hInstance,MAKEINTRESOURCE(100),0,PasswordDialog);
			CleanUp(0,1);
			return(0);
		}

		if(ENCMethod == 3) //  Packed
		{
			Unpack = TRUE; // Unpack File Flag

			DialogBox(hInstance,MAKEINTRESOURCE(100),0,PasswordDialog);
			CleanUp(0,1);
			return(0);
		}

		if(ENCMethod == 4) //  Compressed Encrypted
		{
			DecompressDecrypt = TRUE; // Decompress Decrypt File Flag

			DialogBox(hInstance,MAKEINTRESOURCE(100),0,PasswordDialog);
			CleanUp(0,1);
			return(0);
		}

		if(ENCMethod == 5) //  Compressed Packed
		{
			DecompressUnpack = TRUE; // Decompress Unpack File Flag

			DialogBox(hInstance,MAKEINTRESOURCE(100),0,PasswordDialog);
			CleanUp(0,1);
			return(0);
		}

		if(ENCMethod == 6) // Encrypted by ABI-Coder
		{
			Decrypt = TRUE;   // Decrypt File Flag
			DialogBox(hInstance,MAKEINTRESOURCE(100),0,PasswordDialog);
			CleanUp(0,1);
			return(0);
		}

		if(ENCMethod == 7) // NOT Encrypted
		{
			Encrypt = TRUE; // Encrypt File Flag

			DialogBox(hInstance,MAKEINTRESOURCE(100),0,PasswordDialog);
			CleanUp(0,1);
			return(0);
		}
	}

	CleanUp(0,1);

	return 1;
}

///////////////////////////////////////////////////////////////////////

void ClearBuffer(void)
{
	int LocalLoop;
	LocalLoop = 0;
	while(LocalLoop < sizeof(Buffer))
	{
		Buffer[LocalLoop] = '\0';
		LocalLoop++;
	}
}

///////////////////////////////////////////////////////////////////////

DWORD WINAPI StatusDialog_Thread(LPVOID data)
{
	DialogBox(hInstance,MAKEINTRESOURCE(200),0,StatusDialog);
	return ((DWORD)data);
}

/////////////////////////////////////////////////////////////////////

DWORD WINAPI EncryptProcess_Thread(LPVOID data)
{
	/* Set 128Gamma Priority */
	if( SetPriority() ) return((DWORD)data);

	EncryptProcess();
	return ((DWORD)data);
}

/////////////////////////////////////////////////////////////////////

DWORD WINAPI DecryptProcess_Thread(LPVOID data)
{
	/* Set 128Gamma Priority */
	if( SetPriority() ) return((DWORD)data);

	DecryptProcess();
	return ((DWORD)data);
}

/////////////////////////////////////////////////////////////////////

DWORD WINAPI PackProcess_Thread(LPVOID data)
{
	/* Set 128Gamma Priority */
	if( SetPriority() ) return((DWORD)data);

	PackProcess();
	return ((DWORD)data);
}

/////////////////////////////////////////////////////////////////////

DWORD WINAPI UnpackProcess_Thread(LPVOID data)
{
	/* Set 128Gamma Priority */
	if( SetPriority() ) return((DWORD)data);

	UnpackProcess();
	return ((DWORD)data);
}

/////////////////////////////////////////////////////////////////////

DWORD WINAPI CompressEncryptProcess_Thread(LPVOID data)
{
	/* Set 128Gamma Priority */
	if( SetPriority() ) return((DWORD)data);

	CompressEncryptProcess();
	return ((DWORD)data);
}

/////////////////////////////////////////////////////////////////////

DWORD WINAPI DecompressDecryptProcess_Thread(LPVOID data)
{
	/* Set 128Gamma Priority */
	if( SetPriority() ) return((DWORD)data);

	DecompressDecryptProcess();
	return ((DWORD)data);
}

/////////////////////////////////////////////////////////////////////

DWORD WINAPI CompressPackProcess_Thread(LPVOID data)
{
	/* Set 128Gamma Priority */
	if( SetPriority() ) return((DWORD)data);

	CompressPackProcess();
	return ((DWORD)data);
}

/////////////////////////////////////////////////////////////////////

DWORD WINAPI DecompressUnpackProcess_Thread(LPVOID data)
{
	/* Set 128Gamma Priority */
	if( SetPriority() ) return((DWORD)data);

	DecompressUnpackProcess();
	return ((DWORD)data);
}

//////////////////////////////////////////////////////////////////////

void Update_LastUsed(void)
{
	SetStringValue(HKEY_CLASSES_ROOT,"*\\Shell\\128Gamma_Encryption\\AppInfo\\LastRun","User",Get_UserName());
	SetStringValue(HKEY_CLASSES_ROOT,"*\\Shell\\128Gamma_Encryption\\AppInfo\\LastRun","Date",Get_LongDate());
	SetStringValue(HKEY_CLASSES_ROOT,"*\\Shell\\128Gamma_Encryption\\AppInfo\\LastRun","Time",Get_Time());
}

//////////////////////////////////////////////////////////////////////

void FreeMemory(void)
{
	while(Package.FolderCount != 0)
	{
		free(Package.FolderNames[Package.FolderCount]);
		Package.FolderNames[Package.FolderCount] = '\0';
		Package.FolderCount--;
	}
	while(Package.FileCount != 0)
	{
		free(Package.FileNames[Package.FileCount]);
		Package.FileNames[Package.FileCount] = '\0';
		Package.FileCount--;
	}
}

///////////////////////////////////////////////////////////////////////

void Clear_ReadTemp(void)
{
	int LocalLoop = 0;
	while(LocalLoop < sizeof(ReadTemp))
	{
		ReadTemp[LocalLoop] = '\0';
		LocalLoop++;
	}
}

//////////////////////////////////////////////////////////////////////

int CheckRegistered(void)
{
	DWORD Registration = 0;
	if(GetDWORDValue(HKEY_CLASSES_ROOT,"*\\Shell\\128Gamma_Encryption\\AppInfo\\Registry","Registered",Registration))
	{
		if(Registration == 1)
		{
			Registration = 0;
			if(GetDWORDValue(HKEY_CLASSES_ROOT,"*\\Shell\\128Gamma_Encryption\\AppInfo\\Registry","128Code",Registration))
			{
				if(Registration == RegCode)Registration = 1;
				else Registration = 0;
			}
			else Registration = 0;
		}
		else Registration = 0;
	}
	else Registration = 0;

	if(Registration == 1) // If 128Gamma Is Registered
	{
		Registered = TRUE;
		ShortVersion = Reg_ShortVersion;
		MaxFiles = Reg_MaxFiles;
		MaxPackFileSize = Reg_MaxPackFileSize;
		MaxFileSize = Reg_MaxFileSize;
	}
	else{ // If 128Gamma Is NOT Registered
		Registered = FALSE;

		if(MessageBox(0,"This Is An Unregisterd Version Of 128Gamma.\r\n This message does not apear on registered versions. \r\n\r\n Would you like to buy the full version now?",TitleCaption,4+256+MB_ICONQUESTION + MB_SYSTEMMODAL) == IDYES)
		{
			char GammaPath[1024];
			unsigned long SizeOfGammaPath = sizeof(GammaPath);
			// Get 128Gamma Path
			if(GetStringValue(HKEY_CLASSES_ROOT,"*\\Shell\\128Gamma_Encryption\\AppInfo\\Path","Path",GammaPath,SizeOfGammaPath))
			{
				char Register_EXE[257];
				sprintf(Register_EXE,"%s\\%s",GammaPath,"Register.Exe");
				if(FileAccess(Register_EXE,FExist)) // If Register_EXE Exist
				{
					ShellExecute(0,"open",Register_EXE,"","",SW_NORMAL);
					CleanUp(0,1);
					EndDialog(0,0);
					return 0;
				}
				else{ // If Register_EXE Does Not Exist
					MessageBox(0, "Registration Utility Not Found. \r\nPlease Reinstall 128Gamma." ,TitleCaption,0 + MB_ICONHAND + MB_SYSTEMMODAL);
				}
			}
			else // If Registry Error Or Key Not Found
			MessageBox(0, "Registry Key Not Found. \r\nPlease Reinstall 128Gamma." ,TitleCaption,0 + MB_ICONHAND + MB_SYSTEMMODAL);
		}
		ShortVersion = Unreg_ShortVersion;
		MaxFiles = Unreg_MaxFiles;
		MaxPackFileSize = Unreg_MaxPackFileSize;
		MaxFileSize = Unreg_MaxFileSize;
	}
	return 1;
}

//////////////////////////////////////////////////////////////////////

BOOL SetPriority(void)
{
	DWORD Priority = 0;
	BOOL HighOrRealTime = FALSE;
	HANDLE CurrentProcessHandle = GetCurrentProcess();
	HANDLE CurrentThreadHandle = GetCurrentThread();

	if(GetDWORDValue(HKEY_CLASSES_ROOT,"*\\Shell\\128Gamma_Encryption\\AppInfo\\Priority","Process",Priority))
	{
		if(Priority == 1)SetPriorityClass(CurrentProcessHandle,IDLE_PRIORITY_CLASS);
		if(Priority == 2)SetPriorityClass(CurrentProcessHandle,NORMAL_PRIORITY_CLASS);
		if(Priority == 3)SetPriorityClass(CurrentProcessHandle,HIGH_PRIORITY_CLASS);
		if(Priority == 4)SetPriorityClass(CurrentProcessHandle,REALTIME_PRIORITY_CLASS);
		if(Priority > 2)HighOrRealTime = TRUE;
	}
	else SetDWORDValue(HKEY_CLASSES_ROOT,"*\\Shell\\128Gamma_Encryption\\AppInfo\\Priority","Process",2);

	Priority = 0;

	if(GetDWORDValue(HKEY_CLASSES_ROOT,"*\\Shell\\128Gamma_Encryption\\AppInfo\\Priority","Thread",Priority))
	{
		if(Priority == 1)SetThreadPriority(CurrentThreadHandle,THREAD_PRIORITY_IDLE);
		if(Priority == 2)SetThreadPriority(CurrentThreadHandle,THREAD_PRIORITY_LOWEST);
		if(Priority == 3)SetThreadPriority(CurrentThreadHandle,THREAD_PRIORITY_BELOW_NORMAL);
		if(Priority == 4)SetThreadPriority(CurrentThreadHandle,THREAD_PRIORITY_NORMAL);
		if(Priority == 5)SetThreadPriority(CurrentThreadHandle,THREAD_PRIORITY_ABOVE_NORMAL);
		if(Priority == 6)SetThreadPriority(CurrentThreadHandle,THREAD_PRIORITY_HIGHEST);
		if(Priority == 7)SetThreadPriority(CurrentThreadHandle,THREAD_PRIORITY_TIME_CRITICAL);
		if(Priority > 5)HighOrRealTime = TRUE;
	}
	else SetDWORDValue(HKEY_CLASSES_ROOT,"*\\Shell\\128Gamma_Encryption\\AppInfo\\Priority","Thread",4);

	if(HighOrRealTime == TRUE)
	{
		if(MessageBox(StatusDialog_hWnd,"128Gamma Is Running In High, RealTime Or TimeCritical Mode. \r\nThis Severly Cripples Windows Performance. \r\nContinue Anyway? ",TitleCaption,4+256+MB_ICONQUESTION + MB_SYSTEMMODAL) != 6)
		{
			CancelFlag = TRUE;
			DoneFlag = 1;
			return TRUE;
		}
	}

	Priority = 0;

	if(GetDWORDValue(HKEY_CLASSES_ROOT,"*\\Shell\\128Gamma_Encryption\\AppInfo\\Priority","ThreadBoost",Priority))
	{
		if(Priority == 0)SetThreadPriorityBoost(CurrentThreadHandle,TRUE); //Disable Boost
		if(Priority == 1)SetThreadPriorityBoost(CurrentThreadHandle,FALSE); //Enable Boost
	}
	else SetDWORDValue(HKEY_CLASSES_ROOT,"*\\Shell\\128Gamma_Encryption\\AppInfo\\Priority","ThreadBoost",1);

	Priority = 0;

	if(GetDWORDValue(HKEY_CLASSES_ROOT,"*\\Shell\\128Gamma_Encryption\\AppInfo\\Priority","ProcessBoost",Priority))
	{
		if(Priority == 0)SetProcessPriorityBoost(CurrentProcessHandle,TRUE); //Disable Boost
		if(Priority == 1)SetProcessPriorityBoost(CurrentProcessHandle,FALSE); //Enable Boost
	}
	else SetDWORDValue(HKEY_CLASSES_ROOT,"*\\Shell\\128Gamma_Encryption\\AppInfo\\Priority","ProcessBoost",1);

	return FALSE; // No Error... Return False
}

//////////////////////////////////////////////////////////////////////

