/*
 Processes.H - Functions Used To Call Appropriate Compress/Decompress
				Encrypt/Decrypt, Pack/Unpack

int CompressEncryptProcess(void)
int DecompressDecryptProcess(void)
int CompressPackProcess(void)
int DecompressUnpackProcess(void)
int EncryptProcess(void)
int DecryptProcess(void)
int PackProcess(void)
int UnpackProcess(void)

*/

/////////////////////////////////////////////////////////////////////

int CompressEncryptProcess(void)
{
	char xFile[257];
	char OutPutFile[257];
	float xFileSize = 0;
	char StatusTemp[1024];
	CleanUp(0,1);

	_splitpath(GlobalFileName,NULL,NULL,xFile,NULL);
	sprintf(OutPutFile,"%s.128",GlobalFileName);

	if(FileAccess(OutPutFile,FExist))
	{
		if(MessageBox(StatusDialog_hWnd, "Target File Already Exist. Overwrite?" , TitleCaption, 0 + MB_YESNO + MB_DEFBUTTON2 + MB_ICONQUESTION) == IDNO)
		{
			CleanUp(0,1);
			CancelFlag = TRUE;
			DoneFlag = TRUE;
			return(0);
		}
	}

	xFileSize = Get_FileSize(GlobalFileName);
	if(xFileSize > MaxFileSize)
	{
		char StatusTemp[257];
		sprintf(StatusTemp,"128Gamma %s Cannot Encrypt File Larger Than %d MB.",ShortVersion,MaxFileSize/1024/1024);
		MessageBox (StatusDialog_hWnd, StatusTemp ,TitleCaption,0 + MB_SYSTEMMODAL);
		CleanUp(0,1);
		DoneFlag = 1;
		return(0);
	 }

	CleanUp(0,1);

	xFileSize = Get_FileSize(GlobalFileName);
	sprintf(StatusTemp,"Compressing %.3f MB",xFileSize/1024/1024);
	Status = StatusTemp;

	if(Compress(GlobalFileName,CompressTemp))
	{
		xFileSize = Get_FileSize(CompressTemp);
		sprintf(StatusTemp,"Encrypting %.3f MB",xFileSize/1024/1024);
		Status = StatusTemp;

		if(IncodeMain(CompressTemp,OutPutFile))
		{
			if(DeleteSource)unlink(GlobalFileName);
			Status = "Data Successfully Encrypted!";
		}
	}

	CleanUp(0,1);

	if(CancelFlag)
		unlink(OutPutFile);

	DoneFlag = 1;

	return(0);
}

/////////////////////////////////////////////////////////////////////

int DecompressDecryptProcess(void)
{
	char OutPutFile[257];
	float xFileSize = 0;
	char StatusTemp[1024];
	CleanUp(0,1);

	_splitpath(GlobalFileName,NULL,NULL,OutPutFile,NULL);

	if(FileAccess(OutPutFile,FExist))
	{
		if(MessageBox(StatusDialog_hWnd, "Target File Already Exist. Overwrite?" , TitleCaption, 0 + MB_YESNO + MB_DEFBUTTON2 + MB_ICONQUESTION) == IDNO)
		{
			CleanUp(0,1);
			CancelFlag = TRUE;
			DoneFlag = TRUE;
			return(0);
		}
	}

	xFileSize = Get_FileSize(GlobalFileName);
	sprintf(StatusTemp,"Decrypting %.3f MB",xFileSize/1024/1024);
	Status = StatusTemp;


	if(DecodeMain(GlobalFileName,CompressTemp))
	{
		xFileSize = Get_FileSize(CompressTemp);
		sprintf(StatusTemp,"Decompressing %.3f MB",xFileSize/1024/1024);
		Status = StatusTemp;

		if(Decompress(CompressTemp,OutPutFile))
		{
			if(DeleteSource)unlink(GlobalFileName);
			Status = "Data Successfully Decrypted!";
		}
	}

	CleanUp(0,1);

	if(CancelFlag)
		unlink(OutPutFile);

	DoneFlag = 1;

	return(0);
}

//////////////////////////////////////////////////////////////////////

int CompressPackProcess(void)
{
	char OutPutFile[1024];
	char StatusTemp[1024];
	float xFileSize = 0;

	CleanUp(0,1);
	sprintf(OutPutFile,"%s.128Pkg",GlobalFileName);

	if(FileAccess(OutPutFile,FExist))
	{
		if(MessageBox(StatusDialog_hWnd, "Target File Already Exist. Overwrite?" , TitleCaption, 0 + MB_YESNO + MB_DEFBUTTON2 + MB_ICONQUESTION) == IDNO)
		{
			CleanUp(0,1);
			CancelFlag = TRUE;
			DoneFlag = TRUE;
			return(0);
		}
	}

	if(PackFiles(GlobalFileName,PackTemp))
	{
		xFileSize = Get_FileSize(PackTemp);
		sprintf(StatusTemp,"Compressing %.3f MB",xFileSize/1024/1024);
		Status = StatusTemp;

		if(Compress(PackTemp,CompressTemp))
		{
			xFileSize = Get_FileSize(CompressTemp);
			sprintf(StatusTemp,"Encrypting %.3f MB",xFileSize/1024/1024);
			Status = StatusTemp;

			/* IncodeMain(Source,Target); */
			if(IncodeMain(CompressTemp,OutPutFile))
			{
				if(DeleteSource)
				{
					Status = "Deleting Old Files And Folders.";
					DeleteTree(GlobalFileName);
				}
				Status = "Data Successfully Packed!";
			}
		}
	}

	CleanUp(0,1);

	if(CancelFlag)
		unlink(OutPutFile);

	DoneFlag = 1;

	return(0);
}

//////////////////////////////////////////////////////////////////////

int DecompressUnpackProcess(void)
{
	char OutPutFile[1024];
	char StatusTemp[1024];
	float xFileSize = 0;

	CleanUp(0,1);

	_splitpath(GlobalFileName,NULL,NULL,OutPutFile,NULL);

	if(FileAccess(OutPutFile,FExist))
	{
		if(MessageBox(StatusDialog_hWnd, "Target File Already Exist. Overwrite?" , TitleCaption, 0 + MB_YESNO + MB_DEFBUTTON2 + MB_ICONQUESTION) == IDNO)
		{
			CleanUp(0,1);
			CancelFlag = TRUE;
			DoneFlag = TRUE;
			return(0);
		}
	}

	xFileSize = Get_FileSize(GlobalFileName);
	sprintf(StatusTemp,"Decrypting %.3f MB",xFileSize/1024/1024);
	Status = StatusTemp;

	if(DecodeMain(GlobalFileName,CompressTemp))
	{
		xFileSize = Get_FileSize(CompressTemp);
		sprintf(StatusTemp,"Decompressing %.3f MB",xFileSize/1024/1024);
		Status = StatusTemp;

		if(Decompress(CompressTemp,PackTemp))
		{
			CreateDirectory(OutPutFile,0);
			if(UnPackFiles(PackTemp,OutPutFile))
			{
				if(DeleteSource)unlink(GlobalFileName);
				Status = "Data Successfully Unpacked!";
			}
		}
	}

	CleanUp(0,1);

	if(CancelFlag)
		unlink(OutPutFile);

	DoneFlag = 1;

	return(0);
}

/////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////

int EncryptProcess(void)
{
	char xFile[257];
	char OutPutFile[257];
	float xFileSize = 0;
	char StatusTemp[1024];
	CleanUp(0,1);

	_splitpath(GlobalFileName,NULL,NULL,xFile,NULL);
	sprintf(OutPutFile,"%s.128",GlobalFileName);

	if(FileAccess(OutPutFile,FExist))
	{
		if(MessageBox(StatusDialog_hWnd, "Target File Already Exist. Overwrite?" , TitleCaption, 0 + MB_YESNO + MB_DEFBUTTON2 + MB_ICONQUESTION) == IDNO)
		{
			CleanUp(0,1);
			CancelFlag = TRUE;
			DoneFlag = TRUE;
			return(0);
		}
	}

	xFileSize = Get_FileSize(GlobalFileName);
	if(xFileSize > MaxFileSize)
	{
		char StatusTemp[257];
		CleanUp(0,1);
		DoneFlag = 1;
		sprintf(StatusTemp,"128Gamma %s Cannot Encrypt File Larger Than %d MB.",ShortVersion,MaxFileSize/1024/1024);
		MessageBox (StatusDialog_hWnd, StatusTemp ,TitleCaption,0 + MB_SYSTEMMODAL);
		return(0);
	 }

	CleanUp(0,1);

	xFileSize = Get_FileSize(GlobalFileName);
	sprintf(StatusTemp,"Encrypting %.3f MB",xFileSize/1024/1024);
	Status = StatusTemp;

	if(IncodeMain(GlobalFileName,OutPutFile))
	{
		if(DeleteSource)unlink(GlobalFileName);
		Status = "Data Successfully Encrypted!";
	}

	CleanUp(0,1);

	if(CancelFlag)
		unlink(OutPutFile);

	DoneFlag = 1;

	return(0);
}

/////////////////////////////////////////////////////////////////////

int DecryptProcess(void)
{
	char OutPutFile[257];
	float xFileSize = 0;
	char StatusTemp[1024];
	CleanUp(0,1);

	_splitpath(GlobalFileName,NULL,NULL,OutPutFile,NULL);

	if(FileAccess(OutPutFile,FExist))
	{
		if(MessageBox(StatusDialog_hWnd, "Target File Already Exist. Overwrite?" , TitleCaption, 0 + MB_YESNO + MB_DEFBUTTON2 + MB_ICONQUESTION) == IDNO)
		{
			CleanUp(0,1);
			CancelFlag = TRUE;
			DoneFlag = TRUE;
			return(0);
		}
	}

	xFileSize = Get_FileSize(GlobalFileName);
	sprintf(StatusTemp,"Decrypting %.3f MB",xFileSize/1024/1024);
	Status = StatusTemp;

	if(DecodeMain(GlobalFileName,OutPutFile))
	{
		Status = "Data Successfully Decrypted!";
		if(DeleteSource)unlink(GlobalFileName);
	}

	CleanUp(0,1);

	if(CancelFlag)
		unlink(OutPutFile);

	DoneFlag = 1;

	return(0);
}

//////////////////////////////////////////////////////////////////////

int PackProcess(void)
{
	char OutPutFile[1024];
	char StatusTemp[1024];
	float xFileSize = 0;

	CleanUp(0,1);
	sprintf(OutPutFile,"%s.128Pkg",GlobalFileName);

	if(FileAccess(OutPutFile,FExist))
	{
		if(MessageBox(StatusDialog_hWnd, "Target File Already Exist. Overwrite?" , TitleCaption, 0 + MB_YESNO + MB_DEFBUTTON2 + MB_ICONQUESTION) == IDNO)
		{
			CleanUp(0,1);
			CancelFlag = TRUE;
			DoneFlag = TRUE;
			return(0);
		}
	}

	if(PackFiles(GlobalFileName,PackTemp))
	{
		xFileSize = Get_FileSize(PackTemp);
		sprintf(StatusTemp,"Encrypting %.3f MB",xFileSize/1024/1024);
		Status = StatusTemp;

		/* IncodeMain(Source,Target); */
		if(IncodeMain(PackTemp,OutPutFile))
		{
			if(DeleteSource)
			{
				Status = "Deleting Old Files And Folders.";
				DeleteTree(GlobalFileName);
			}
			Status = "Data Successfully Packed!";
		}
	}

	CleanUp(0,1);

	if(CancelFlag)
		unlink(OutPutFile);

	DoneFlag = 1;

	return(0);
}

//////////////////////////////////////////////////////////////////////

int UnpackProcess(void)
{
	char OutPutFile[1024];
	char StatusTemp[1024];
	float xFileSize = 0;

	CleanUp(0,1);

	_splitpath(GlobalFileName,NULL,NULL,OutPutFile,NULL);

	if(FileAccess(OutPutFile,FExist))
	{
		if(MessageBox(StatusDialog_hWnd, "Target File Already Exist. Overwrite?" , TitleCaption, 0 + MB_YESNO + MB_DEFBUTTON2 + MB_ICONQUESTION) == IDNO)
		{
			CleanUp(0,1);
			CancelFlag = TRUE;
			DoneFlag = TRUE;
			return(0);
		}
	}

	xFileSize = Get_FileSize(GlobalFileName);
	sprintf(StatusTemp,"Decrypting %.3f MB",xFileSize/1024/1024);
	Status = StatusTemp;

	if(DecodeMain(GlobalFileName,PackTemp))
	{
		CreateDirectory(OutPutFile,0);
		if(UnPackFiles(PackTemp,OutPutFile))
		{
			Status = "Data Successfully Unpacked!";
			if(DeleteSource)unlink(GlobalFileName);
		}
	}

	CleanUp(0,1);

	if(CancelFlag)
		unlink(OutPutFile);

	DoneFlag = 1;

	return(0);
}

/////////////////////////////////////////////////////////////////////

